#ifndef lint
static char const 
yyrcsid[] = "$FreeBSD: src/usr.bin/yacc/skeleton.c,v 1.28 2000/01/17 02:04:06 bde Exp $";
#endif
#include <stdlib.h>
#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define YYLEX yylex()
#define YYEMPTY -1
#define yyclearin (yychar=(YYEMPTY))
#define yyerrok (yyerrflag=0)
#define YYRECOVERING() (yyerrflag!=0)
static int yygrowstack();
#define yyparse H5EDITyyparse
#define yylex H5EDITyylex
#define yyerror H5EDITyyerror
#define yychar H5EDITyychar
#define yyval H5EDITyyval
#define yylval H5EDITyylval
#define yydebug H5EDITyydebug
#define yynerrs H5EDITyynerrs
#define yyerrflag H5EDITyyerrflag
#define yyss H5EDITyyss
#define yyssp H5EDITyyssp
#define yyvs H5EDITyyvs
#define yyvsp H5EDITyyvsp
#define yylhs H5EDITyylhs
#define yylen H5EDITyylen
#define yydefred H5EDITyydefred
#define yydgoto H5EDITyydgoto
#define yysindex H5EDITyysindex
#define yyrindex H5EDITyyrindex
#define yygindex H5EDITyygindex
#define yytable H5EDITyytable
#define yycheck H5EDITyycheck
#define yyname H5EDITyyname
#define yyrule H5EDITyyrule
#define yysslim H5EDITyysslim
#define yystacksize H5EDITyystacksize
#define YYPREFIX "H5EDITyy"
#line 11 "parse.y"
#include<h5edit.h>

extern int yylex();
extern int yyerror(char *);

#define STACK_SIZE      16
#define DATA_SIZE_MAX	512	/* max number of data points */

/* types definitions */
/* nothing yet */

/* variables */
/* Attribute name and handle */
char		*attribute_name = NULL;
char		*attribute_name_new = NULL;
char		*attribute_name_old = NULL;
hid_t		attribute_id = -1;
char		*attribute_type_name = NULL;
hid_t		attribute_type_id = -1;
H5T_class_t	attribute_type_class = H5T_NO_CLASS;
hid_t		attribute_space_id = -1;
H5S_class_t	attribute_space_class = H5S_NO_CLASS;
H5T_class_t	data_value_class = H5T_NO_CLASS;
struct arr_info	attribute_dims;			/* attribute dimension */

/* names for COPY command */
char            *destination_attribute_name = NULL;
char            *source_object_name = NULL;
char            *destination_object_name = NULL;
char            *source_attribute_part = NULL;
char            *source_object_part = NULL;
char            *destination_attribute_part = NULL;
char            *destination_object_part = NULL;
char            *copy_param2_name = NULL;

		/* attribute data buffer */
/*void		*attribute_data = NULL; */
		/* this approach does not work for compound types */
union {
    int		data_int[DATA_SIZE_MAX];	/* attribute integer data */
    double	data_float[DATA_SIZE_MAX];	/* attribute float data */
    char	data_string[DATA_SIZE_MAX];	/* attribute string data */
    char	data_char[DATA_SIZE_MAX];	/* for SCALAR string data */
} attribute_data;
int		attribute_data_needed = -1;
int		attribute_data_gotten = -1;
		/* points to available string data buffer */
char*		attribute_data_pt = &(attribute_data.data_string);



/* Dataset name and handle */
char	*group_name = NULL;
char	*dataset_name = NULL;
hid_t	dataset_id = -1;

/*structure for array type information*/
struct arr_info {
    hsize_t	dims[H5S_MAX_RANK];     /*size of each dimension, limited to 32 dimensions*/
    int		ndims;                  /*number of dimensions*/
    hbool_t	is_dim;                 /*flag to lexer for dimension*/
};


/*structure for compound type information*/
struct cmpd_info {
    hid_t       id;             /*type ID*/
    hbool_t     is_field;       /*flag to lexer for compound member*/
    hbool_t     first_memb;     /*flag for first compound member*/
};

/*stack for nested compound type*/
struct cmpd_info h5edit_cmpd_stack[STACK_SIZE] = {
    {0, 0, 1}, {0, 0, 1}, {0, 0, 1}, {0, 0, 1},
    {0, 0, 1}, {0, 0, 1}, {0, 0, 1}, {0, 0, 1},
    {0, 0, 1}, {0, 0, 1}, {0, 0, 1}, {0, 0, 1},
    {0, 0, 1}, {0, 0, 1}, {0, 0, 1}, {0, 0, 1} };

int h5edit_csindex = -1;                /*pointer to the top of compound stack*/

/*stack for nested array type*/
struct arr_info arr_stack[STACK_SIZE];
int h5edit_asindex = -1;               /*pointer to the top of array stack*/ 

hbool_t     h5edit_is_str_size = 0;        /*flag to lexer for string size*/
/*hbool_t     is_str_pad = 0;         */ /*flag to lexer for string padding*/
H5T_pad_t   str_pad;                /*variable for string padding*/
H5T_cset_t  str_cset;               /*variable for string character set*/
hbool_t     h5edit_is_variable = 0;        /*variable for variable-length string*/
int      str_size;               /*variable for string size*/
   

#line 104 "parse.y"
typedef union {
    int   ival;         /*for integer token*/
    double fval;	/*for floating point token */
    char  *sval;        /*for name string*/
} YYSTYPE;
#line 142 "parse.c"
#define YYERRCODE 256
#define CREATE_KWORD 257
#define DELETE_KWORD 258
#define RENAME_KWORD 259
#define COPY_KWORD 260
#define ATTRIBUTE_KWORD 261
#define DATASET_KWORD 262
#define GROUP_KWORD 263
#define DATATYPE_KWORD 264
#define DATASPACE_KWORD 265
#define DATA_KWORD 266
#define IDENTIFIER 267
#define PATHNAME 268
#define QUOTED_STRING 269
#define DQUOTED_STRING 270
#define EOSTMT_TOKEN 271
#define WSPACE 272
#define INTEGER_TYPE_TOKEN 273
#define FLOAT_TYPE_TOKEN 274
#define H5T_STD_I8BE_TOKEN 275
#define H5T_STD_I8LE_TOKEN 276
#define H5T_STD_I16BE_TOKEN 277
#define H5T_STD_I16LE_TOKEN 278
#define H5T_STD_I32BE_TOKEN 279
#define H5T_STD_I32LE_TOKEN 280
#define H5T_STD_I64BE_TOKEN 281
#define H5T_STD_I64LE_TOKEN 282
#define H5T_STD_U8BE_TOKEN 283
#define H5T_STD_U8LE_TOKEN 284
#define H5T_STD_U16BE_TOKEN 285
#define H5T_STD_U16LE_TOKEN 286
#define H5T_STD_U32BE_TOKEN 287
#define H5T_STD_U32LE_TOKEN 288
#define H5T_STD_U64BE_TOKEN 289
#define H5T_STD_U64LE_TOKEN 290
#define H5T_NATIVE_CHAR_TOKEN 291
#define H5T_NATIVE_SCHAR_TOKEN 292
#define H5T_NATIVE_UCHAR_TOKEN 293
#define H5T_NATIVE_SHORT_TOKEN 294
#define H5T_NATIVE_USHORT_TOKEN 295
#define H5T_NATIVE_INT_TOKEN 296
#define H5T_NATIVE_UINT_TOKEN 297
#define H5T_NATIVE_LONG_TOKEN 298
#define H5T_NATIVE_ULONG_TOKEN 299
#define H5T_NATIVE_LLONG_TOKEN 300
#define H5T_NATIVE_ULLONG_TOKEN 301
#define H5T_IEEE_F32BE_TOKEN 302
#define H5T_IEEE_F32LE_TOKEN 303
#define H5T_IEEE_F64BE_TOKEN 304
#define H5T_IEEE_F64LE_TOKEN 305
#define H5T_NATIVE_FLOAT_TOKEN 306
#define H5T_NATIVE_DOUBLE_TOKEN 307
#define H5T_NATIVE_LDOUBLE_TOKEN 308
#define H5T_STRING_TOKEN 309
#define STRSIZE_TOKEN 310
#define STRPAD_TOKEN 311
#define CSET_TOKEN 312
#define CTYPE_TOKEN 313
#define H5T_VARIABLE_TOKEN 314
#define H5T_STR_NULLTERM_TOKEN 315
#define H5T_STR_NULLPAD_TOKEN 316
#define H5T_STR_SPACEPAD_TOKEN 317
#define H5T_CSET_ASCII_TOKEN 318
#define H5T_CSET_UTF8_TOKEN 319
#define H5T_C_S1_TOKEN 320
#define H5T_FORTRAN_S1_TOKEN 321
#define H5T_COMPOUND_TOKEN 322
#define H5T_ARRAY_TOKEN 323
#define H5T_VLEN_TOKEN 324
#define STRING_CONST 325
#define INTEGER_CONST 326
#define FLOAT_CONST 327
#define SCALAR_TOKEN 328
#define SIMPLE_TOKEN 329
#define NULL_TOKEN 330
const short H5EDITyylhs[] = {                                        -1,
    0,    0,    1,    2,    2,    2,    2,    4,    4,    5,
    5,    7,    7,    8,    9,   10,   11,   13,   12,   16,
   18,   22,   23,   17,   19,   20,   14,   14,   14,   24,
   25,   21,   21,   21,   21,    3,   15,   26,   26,   26,
   26,   27,   27,   30,   31,   31,   31,   34,   35,   36,
   37,   37,   32,   33,   28,   28,   38,   38,   38,   40,
   39,   39,   43,   42,   44,   45,   45,   46,   41,   29,
   29,   49,   51,   47,   48,   50,   50,   53,   52,   52,
   52,    6,    6,   54,   55,
};
const short H5EDITyylen[] = {                                         2,
    0,    2,    2,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    3,    4,    2,    3,    3,    5,    1,
    1,    1,    1,    1,    1,    1,    1,    2,    2,    1,
    1,    1,    1,    1,    1,    1,    3,    3,    2,    2,
    1,    2,    1,    1,    1,    1,    1,    4,    1,    2,
    1,    1,    1,    1,    2,    1,    1,    1,    1,    1,
    2,    1,    0,    5,    1,    0,    2,    2,    1,    2,
    1,    0,    0,    6,    1,    0,    2,    2,    1,    1,
    1,    1,    1,    4,    3,
};
const short H5EDITyydefred[] = {                                      1,
    0,    0,    0,    0,    0,    2,    0,    4,    5,    6,
    7,    8,    9,   10,   11,   12,   13,   82,   83,    0,
    0,   32,   33,   34,   35,    0,   30,   27,    0,    0,
   24,    0,   36,    3,   28,   31,   29,    0,   14,    0,
   20,   17,    0,    0,   85,    0,   21,    0,    0,    0,
   53,   54,    0,   72,   60,   63,   69,    0,    0,    0,
   41,   43,   44,   45,   46,   47,   56,   57,   58,   59,
   62,    0,   71,   15,   23,   84,   25,    0,   42,   55,
   70,    0,    0,   61,   37,    0,   39,   40,    0,   19,
   26,    0,    0,   49,   51,   52,   79,   80,   81,   76,
   75,   38,   65,   66,   50,   48,    0,    0,    0,    0,
   77,   64,    0,   67,   78,   74,   68,
};
const short H5EDITyydgoto[] = {                                       1,
    6,    7,   34,    8,    9,   10,   11,   12,   13,   14,
   15,   16,   17,   26,   39,   40,   32,   46,   78,   90,
   27,   44,   45,   28,   37,   58,   59,   60,   61,   62,
   63,   64,   65,   66,   93,   94,   99,   67,   68,   69,
   70,   71,   72,  104,  108,  114,   73,  100,   83,  107,
  110,  101,  111,   18,   19,
};
const short H5EDITyysindex[] = {                                      0,
 -218, -241, -241, -241, -256,    0, -251,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, -223,
 -223,    0,    0,    0,    0, -115,    0,    0, -223, -223,
    0, -223,    0,    0,    0,    0,    0, -123,    0,  -75,
    0,    0,    0, -223,    0, -219,    0, -259, -298,  -72,
    0,    0,  -71,    0,    0,    0,    0,  -70, -120, -122,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   13,    0,    0,    0,    0,    0, -223,    0,    0,
    0, -254, -265,    0,    0, -122,    0,    0, -272,    0,
    0, -269,  -67,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   16,  -35, -265,  -62,
    0,    0, -262,    0,    0,    0,    0,
};
const short H5EDITyyrindex[] = {                                      0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, -206,    0,
    0,    0,    0,    0,    0,    0,    0,   26,    0,    0,
    0,    0, -233,    0,    0, -204,    0,    0,   26,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   26,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  -57,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,
};
const short H5EDITyygindex[] = {                                      0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   20,   29,  -11,    0,    0,    0,    0,
  -19,    0,   27,   50,    0,    0,    0,   14,  -43,   24,
    0,    0,    0,    0,    0,    0,    0,   25,    0,    0,
    0,   19,    0,    0,    0,    0,   28,    0,    0,    0,
    0,  -33,    0,    0,    0,
};
#define YYTABLESIZE 210
const short H5EDITyytable[] = {                                      54,
   54,   36,   54,   95,   96,  112,   41,   38,  113,   41,
   41,   31,   47,   51,   52,   87,   88,   42,   43,   33,
   20,   21,   29,   30,   41,   22,   23,   24,   25,   55,
   56,   57,   75,   22,   22,   22,   22,   23,    2,    3,
    4,    5,  102,   22,   23,   24,   25,   38,   77,   53,
   54,   82,   89,  103,   85,   92,  105,  106,   91,  109,
   97,   98,  116,  117,   16,   63,   18,   73,   74,   35,
   76,   79,   86,   80,   84,  115,    0,   81,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   48,   49,   50,   50,   49,   50,    0,    0,    0,   51,
   52,   22,   23,   24,   25,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   53,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   55,   56,   57,   55,   56,   57,
};
const short H5EDITyycheck[] = {                                     123,
  123,   21,  123,  269,  270,   41,   26,  123,   44,   29,
   30,  268,   32,  273,  274,   59,   60,   29,   30,  271,
  262,  263,    3,    4,   44,  267,  268,  269,  270,  328,
  329,  330,   44,  267,  268,  269,  270,  271,  257,  258,
  259,  260,   86,  267,  268,  269,  270,  123,  268,  309,
  123,  123,   40,  326,  125,  310,  326,  125,   78,   44,
  326,  327,  125,  326,  271,   40,  271,  125,   40,   20,
   44,   48,   59,   49,   56,  109,   -1,   50,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  264,  265,  266,  266,  265,  266,   -1,   -1,   -1,  273,
  274,  267,  268,  269,  270,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  309,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  328,  329,  330,  328,  329,  330,
};
#define YYFINAL 1
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 330
#if YYDEBUG
const char * const H5EDITyyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,"'('","')'",0,0,"','",0,0,0,0,0,0,0,0,0,0,0,0,0,"':'",0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"'['",0,"']'",0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"'{'",0,"'}'",0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
"CREATE_KWORD","DELETE_KWORD","RENAME_KWORD","COPY_KWORD","ATTRIBUTE_KWORD",
"DATASET_KWORD","GROUP_KWORD","DATATYPE_KWORD","DATASPACE_KWORD","DATA_KWORD",
"IDENTIFIER","PATHNAME","QUOTED_STRING","DQUOTED_STRING","EOSTMT_TOKEN",
"WSPACE","INTEGER_TYPE_TOKEN","FLOAT_TYPE_TOKEN","H5T_STD_I8BE_TOKEN",
"H5T_STD_I8LE_TOKEN","H5T_STD_I16BE_TOKEN","H5T_STD_I16LE_TOKEN",
"H5T_STD_I32BE_TOKEN","H5T_STD_I32LE_TOKEN","H5T_STD_I64BE_TOKEN",
"H5T_STD_I64LE_TOKEN","H5T_STD_U8BE_TOKEN","H5T_STD_U8LE_TOKEN",
"H5T_STD_U16BE_TOKEN","H5T_STD_U16LE_TOKEN","H5T_STD_U32BE_TOKEN",
"H5T_STD_U32LE_TOKEN","H5T_STD_U64BE_TOKEN","H5T_STD_U64LE_TOKEN",
"H5T_NATIVE_CHAR_TOKEN","H5T_NATIVE_SCHAR_TOKEN","H5T_NATIVE_UCHAR_TOKEN",
"H5T_NATIVE_SHORT_TOKEN","H5T_NATIVE_USHORT_TOKEN","H5T_NATIVE_INT_TOKEN",
"H5T_NATIVE_UINT_TOKEN","H5T_NATIVE_LONG_TOKEN","H5T_NATIVE_ULONG_TOKEN",
"H5T_NATIVE_LLONG_TOKEN","H5T_NATIVE_ULLONG_TOKEN","H5T_IEEE_F32BE_TOKEN",
"H5T_IEEE_F32LE_TOKEN","H5T_IEEE_F64BE_TOKEN","H5T_IEEE_F64LE_TOKEN",
"H5T_NATIVE_FLOAT_TOKEN","H5T_NATIVE_DOUBLE_TOKEN","H5T_NATIVE_LDOUBLE_TOKEN",
"H5T_STRING_TOKEN","STRSIZE_TOKEN","STRPAD_TOKEN","CSET_TOKEN","CTYPE_TOKEN",
"H5T_VARIABLE_TOKEN","H5T_STR_NULLTERM_TOKEN","H5T_STR_NULLPAD_TOKEN",
"H5T_STR_SPACEPAD_TOKEN","H5T_CSET_ASCII_TOKEN","H5T_CSET_UTF8_TOKEN",
"H5T_C_S1_TOKEN","H5T_FORTRAN_S1_TOKEN","H5T_COMPOUND_TOKEN","H5T_ARRAY_TOKEN",
"H5T_VLEN_TOKEN","STRING_CONST","INTEGER_CONST","FLOAT_CONST","SCALAR_TOKEN",
"SIMPLE_TOKEN","NULL_TOKEN",
};
const char * const H5EDITyyrule[] = {
"$accept : editstmts",
"editstmts :",
"editstmts : editstmts editstmt",
"editstmt : editcmd eostmt",
"editcmd : create_cmd",
"editcmd : delete_cmd",
"editcmd : rename_cmd",
"editcmd : copy_cmd",
"create_cmd : create_cmd1",
"create_cmd : create_cmd2",
"delete_cmd : delete_cmd1",
"delete_cmd : delete_cmd2",
"copy_cmd : copy_cmd1",
"copy_cmd : copy_cmd2",
"create_cmd1 : CREATE_KWORD targetobject attribute_definition",
"create_cmd2 : CREATE_KWORD targetobject attributename attribute_definition",
"delete_cmd1 : DELETE_KWORD targetobject",
"delete_cmd2 : DELETE_KWORD targetobject attributename",
"copy_cmd2 : COPY_KWORD sourceobjectname copyparam2",
"copy_cmd1 : COPY_KWORD sourceobjectname copyparam2 destinationobjectname destinationattributename",
"attributename : objectname",
"copyparam2 : objectname",
"attrname_old : attributename",
"attrname_new : attributename",
"sourceobjectname : PATHNAME",
"destinationobjectname : PATHNAME",
"destinationattributename : objectname",
"targetobject : datasetname",
"targetobject : DATASET_KWORD datasetname",
"targetobject : GROUP_KWORD groupname",
"datasetname : objectname",
"groupname : objectname",
"objectname : IDENTIFIER",
"objectname : PATHNAME",
"objectname : QUOTED_STRING",
"objectname : DQUOTED_STRING",
"eostmt : EOSTMT_TOKEN",
"attribute_definition : '{' attribute_body_definition '}'",
"attribute_body_definition : datatype_stmt dataspace_stmt data_stmt",
"attribute_body_definition : datatype_stmt data_stmt",
"attribute_body_definition : dataspace_stmt data_stmt",
"attribute_body_definition : data_stmt",
"datatype_stmt : DATATYPE_KWORD datatype_definition",
"datatype_stmt : datatype_definition",
"datatype_definition : datatype_class",
"datatype_class : integer_class",
"datatype_class : floatpoint_class",
"datatype_class : string_class",
"string_class : H5T_STRING_TOKEN '{' string_type_definition '}'",
"string_type_definition : string_size_definition",
"string_size_definition : STRSIZE_TOKEN INTEGER_CONST",
"string_const : QUOTED_STRING",
"string_const : DQUOTED_STRING",
"integer_class : INTEGER_TYPE_TOKEN",
"floatpoint_class : FLOAT_TYPE_TOKEN",
"dataspace_stmt : DATASPACE_KWORD dataspace_definition",
"dataspace_stmt : dataspace_definition",
"dataspace_definition : dataspace_simple",
"dataspace_definition : dataspace_scalar",
"dataspace_definition : dataspace_null",
"dataspace_scalar : SCALAR_TOKEN",
"dataspace_simple : SIMPLE_TOKEN dataspace_dims_list",
"dataspace_simple : dataspace_dims_list",
"$$1 :",
"dataspace_dims_list : $$1 '(' dim_firstone dims_list ')'",
"dim_firstone : INTEGER_CONST",
"dims_list :",
"dims_list : dims_list dim_more",
"dim_more : ',' INTEGER_CONST",
"dataspace_null : NULL_TOKEN",
"data_stmt : DATA_KWORD data_definition",
"data_stmt : data_definition",
"$$2 :",
"$$3 :",
"data_definition : '{' $$2 data_firstval data_list $$3 '}'",
"data_firstval : data_val",
"data_list :",
"data_list : data_list data_more",
"data_more : ',' data_val",
"data_val : INTEGER_CONST",
"data_val : FLOAT_CONST",
"data_val : string_const",
"rename_cmd : rename_cmd1",
"rename_cmd : rename_cmd2",
"rename_cmd1 : RENAME_KWORD targetobject attrname_old attrname_new",
"rename_cmd2 : RENAME_KWORD targetobject attrname_new",
};
#endif
#if YYDEBUG
#include <stdio.h>
#endif
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 10000
#define YYMAXDEPTH 10000
#endif
#endif
#define YYINITSTACKSIZE 200
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short *yyss;
short *yysslim;
YYSTYPE *yyvs;
int yystacksize;
#line 1025 "parse.y"

/* subroutine section */
char* strrstr ( const char* str1, const char* str2 );

/**
* Strip the final identifier (legal attributname) from a pathname.
* This allows us to deal with a combined objectpath/attributename
* construct.
*
* Input: the pathname
* Output: the (potential, if trimmed) object name
* Result: the (potential, if trimmed) attribute name
*/
char * split_object_component ( char *pathname, char **trim_pathname )
{
    char *split_ptr = NULL;    /* pointer to split point */
    char *split_ptr0 = NULL;   /* temporary pointer to split point */
    char *attr_ptr = NULL;     /* pointer to final object segment */

    /* split at final occurrence of double slash. */
    *trim_pathname = HDstrdup( pathname );
    if (split_ptr = strrstr( *trim_pathname, "//" )) {
        *split_ptr++ = '\0';
        attr_ptr = split_ptr;
        if (get_debug()) fprintf( stderr, "Split: doubleslash\n" );
    }
    /*  split at penultimate occurrence of single or double quote; remove quotes */
    else if (split_final_quoted_string(pathname,trim_pathname,&attr_ptr)) {
        if (get_debug()) fprintf( stderr, "Split: quotes\n" );
        /* don't need to do anything else */
    }
    /* split at final occurrence of slash. */
    else if (split_ptr = strrchr( (const char*)*trim_pathname, '/' )) {
        *split_ptr++ = '\0';
        if (get_debug()) fprintf( stderr, "split: final slash\n" );
        attr_ptr = split_ptr;
        /* pathological case: root object */
        if (*trim_pathname[0] == '\0') {
            *trim_pathname = HDstrdup( "/" );
        }
    }
    else
        if (get_debug()) fprintf( stderr, "split: none found!\n" );

    if (get_debug())
        fprintf( stderr, "Object part: '%s'; Attr part: '%s'\n", *trim_pathname, attr_ptr );

    return attr_ptr;
}

/*
* if final token is a quoted string, return true and set return variables
* to reflect the object and attribute parts.
*/
int split_final_quoted_string( char *pathname, char **trim_pathname, char **trim_attr ) 
{
    char    *trimptr = NULL;
    char    final = 0;
    int     pos = -1;

    /* can't be a non-zero-length quoted string */
    if (!pathname || (strlen(pathname) < 3)) return 0;

    /* final character has to be a single- or double-quote */
    final = pathname[strlen(pathname)-1];
    if (((char)final == '"') || ((char)final == '\'')) {
        if (get_debug()) fprintf( stderr, "Got a quote: %c\n", final );
        pos = strlen(*trim_pathname)-1;
        if (get_debug()) fprintf( stderr, "   final position: %d\n", pos );
        /* *trim_pathname[strlen(*trim_pathname)-1] = '\0'; *//* remove the trailing quote */
        (*trim_pathname)[pos] = '\0'; /* remove the trailing quote */
        if (get_debug()) fprintf( stderr, "   removed trailing quote\n" );
        if (trimptr = strrchr( *trim_pathname, final )) {    /* found first quote */
            if (get_debug()) fprintf( stderr, "   found startf of token\n" );
            *trimptr++ = '\0';
            if (get_debug()) fprintf( stderr, "   split string\n" );
            *trim_attr = trimptr;
            if (get_debug()) fprintf( stderr, "   tweaking attr ptr\n" );
            return 1;
        }
        else {
            /* FIXME: restore trim_pathname */
            if (get_debug()) fprintf( stderr, "   repairing pathname\n" );
            (*trim_pathname)[strlen(*trim_pathname)] = (char)final;
        }
    }

    /* return false */
    return 0;
}
/*
* Find last (rightmost) occurrence of string str2 in string str1.
*/
char* strrstr ( const char* str1, const char* str2 )
{
  char* strp;
  int len1, len2;

  len2 = strlen(str2);
  if(len2==0)
    return (char*)str1;

  len1 = strlen(str1);
  if(len1 - len2 <= 0)
    return 0;
   
  strp = (char*)(str1 + len1 - len2);
  while(strp != str1)
  {
    if(*strp == *str2)
    {
      if(strncmp(strp,str2,len2)==0)
        return strp;
    }
    strp--;
  }
  return 0;
}
#line 616 "parse.c"
/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack()
{
    int newsize, i;
    short *newss;
    YYSTYPE *newvs;

    if ((newsize = yystacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return -1;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;
    i = yyssp - yyss;
    newss = yyss ? (short *)realloc(yyss, newsize * sizeof *newss) :
      (short *)malloc(newsize * sizeof *newss);
    if (newss == NULL)
        return -1;
    yyss = newss;
    yyssp = newss + i;
    newvs = yyvs ? (YYSTYPE *)realloc(yyvs, newsize * sizeof *newvs) :
      (YYSTYPE *)malloc(newsize * sizeof *newvs);
    if (newvs == NULL)
        return -1;
    yyvs = newvs;
    yyvsp = newvs + i;
    yystacksize = newsize;
    yysslim = yyss + newsize - 1;
    return 0;
}

#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab

#ifndef YYPARSE_PARAM
#if defined(__cplusplus) || __STDC__
#define YYPARSE_PARAM_ARG void
#define YYPARSE_PARAM_DECL
#else	/* ! ANSI-C/C++ */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif	/* ANSI-C/C++ */
#else	/* YYPARSE_PARAM */
#ifndef YYPARSE_PARAM_TYPE
#define YYPARSE_PARAM_TYPE void *
#endif
#if defined(__cplusplus) || __STDC__
#define YYPARSE_PARAM_ARG YYPARSE_PARAM_TYPE YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else	/* ! ANSI-C/C++ */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL YYPARSE_PARAM_TYPE YYPARSE_PARAM;
#endif	/* ANSI-C/C++ */
#endif	/* ! YYPARSE_PARAM */

int
yyparse (YYPARSE_PARAM_ARG)
    YYPARSE_PARAM_DECL
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register const char *yys;

    if ((yys = getenv("YYDEBUG")))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    if (yyss == NULL && yygrowstack()) goto yyoverflow;
    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if ((yyn = yydefred[yystate])) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yysslim && yygrowstack())
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#if defined(lint) || defined(__GNUC__)
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#if defined(lint) || defined(__GNUC__)
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yysslim && yygrowstack())
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 3:
#line 160 "parse.y"
{
			    if (get_debug()) fprintf(stderr, "end of command.\n");
			    if (atomic_level_g == Inc_atomic){
				updatebackupfile();
				if (get_debug()) fprintf(stderr, "backup file updated.\n");
			    }

			}
break;
case 14:
#line 194 "parse.y"
{
			    if (get_debug()) fprintf(stderr, "found create command syntax 1\n");
			    /* error check */
			    if (!dataset_name && !group_name){
				fprintf(stderr, "neither dataset nor group name is provided for CREATE command\n");
				leave(EXIT_FAILURE);
			    }
			    /* Execute the CREATE command */
			    /* Sending NULL for attribute_name because it is not defined. */
			    if (0 != create_attribute(NULL, group_name, dataset_name,
				attribute_type_id, attribute_space_id, &attribute_data)){
				CMD_ERROR("CREATE Attribute command failed");
			    }
			    /* Cleanup */
			    if (group_name){
				HDfree(group_name);
				group_name = NULL;
			    }
			    if (dataset_name){
				HDfree(dataset_name);
				dataset_name = NULL;
			    }
			    attribute_data_needed = -1;

			    if (attribute_space_id >= 0){
				H5Sclose(attribute_space_id);
				attribute_space_id = -1;
			    }
			    if (attribute_type_id >= 0){
				H5Tclose(attribute_type_id);
				attribute_type_id = -1;
			    }
			    attribute_type_class = H5T_NO_CLASS;
			}
break;
case 15:
#line 231 "parse.y"
{
			    if (get_debug()) fprintf(stderr, "found create command\n");
			    /* error check */
			    if (!attribute_name){
				fprintf(stderr, "attribute name missing from CREATE command\n");
				leave(EXIT_FAILURE);
			    }
			    if (!dataset_name && !group_name){
				fprintf(stderr, "neither dataset nor group name is provided for CREATE command\n");
				leave(EXIT_FAILURE);
			    }
			    /* Execute the CREATE command */
			    if (0 != create_attribute(attribute_name, group_name, dataset_name,
				attribute_type_id, attribute_space_id, &attribute_data)){
				CMD_ERROR("CREATE Attribute command failed");
			    }
			    /* Cleanup */
			    HDfree(attribute_name);
			    attribute_name = NULL;
			    if (group_name){
				HDfree(group_name);
				group_name = NULL;
			    }
			    if (dataset_name){
				HDfree(dataset_name);
				dataset_name = NULL;
			    }
			    attribute_data_needed = -1;

			    if (attribute_space_id >= 0){
				H5Sclose(attribute_space_id);
				attribute_space_id = -1;
			    }
			    if (attribute_type_id >= 0){
				H5Tclose(attribute_type_id);
				attribute_type_id = -1;
			    }
			    attribute_type_class = H5T_NO_CLASS;
			}
break;
case 16:
#line 274 "parse.y"
{
			    if (get_debug()) fprintf(stderr, "found delete command syntax 1\n");
			    /* error check */
			    if (!dataset_name && !group_name){
				fprintf(stderr, "neither dataset nor group name is provided for DELETE command\n");
				leave(EXIT_FAILURE);
			    }
			    /* Execute the DELETE command */
			    /* Sending NULL for attribute_name because it is not defined. */
			    if (0 != delete_attribute(NULL, group_name, dataset_name)){
				CMD_ERROR("DELETE Attribute command failed");
			    }
			    /* Cleanup */
			    if (group_name){
				HDfree(group_name);
				group_name = NULL;
			    }
			    if (dataset_name){
				HDfree(dataset_name);
				dataset_name = NULL;
			    }
			}
break;
case 17:
#line 300 "parse.y"
{
			    if (get_debug()) fprintf(stderr, "found delete command\n");
			    /* error check */
			    if (!attribute_name){
				fprintf(stderr, "attribute name missing from DELETE command\n");
				leave(EXIT_FAILURE);
			    }
			    if (!dataset_name && !group_name){
				fprintf(stderr, "neither dataset nor group name is provided for DELETE command\n");
				leave(EXIT_FAILURE);
			    }
			    /* Execute the DELETE command */
			    if (0 != delete_attribute(attribute_name, group_name, dataset_name)){
				CMD_ERROR("DELETE Attribute command failed");
			    }
			    /* Cleanup */
			    HDfree(attribute_name);
			    attribute_name = NULL;
			    if (group_name){
				HDfree(group_name);
				group_name = NULL;
			    }
			    if (dataset_name){
				HDfree(dataset_name);
				dataset_name = NULL;
			    }
			}
break;
case 18:
#line 332 "parse.y"
{
			    if (get_debug()) fprintf(stderr, "found copy2 command\n");
                            if (!source_object_name){
                                fprintf(stderr, "source object is missing for COPY command\n");
                                leave(EXIT_FAILURE);
                            }
                            if (!copy_param2_name){
                                fprintf(stderr, "destination is missing for COPY command\n");
                                leave(EXIT_FAILURE);
                            }
                            /* split  source object and attribute names */
                            source_attribute_part = split_object_component( source_object_name,
					&source_object_part );
                            if (!source_object_part){
                                fprintf(stderr, "source object name couldn't be found for COPY command\n");
                                leave(EXIT_FAILURE);
                            }
                            if (!source_attribute_part){
                                fprintf(stderr, "source attribute name couldn't be found for COPY command\n");
                                leave(EXIT_FAILURE);
                            }
                            /* split destination object and attribute names */
                            destination_attribute_part = split_object_component( copy_param2_name,
					&destination_object_part );
                            if (!destination_object_part){
                                fprintf(stderr, "destination object name couldn't be found for COPY command\n");
                                leave(EXIT_FAILURE);
                            }
			    /* in this case we assume no destination object so use the source object */
                            if (!destination_attribute_part){
				destination_attribute_part = copy_param2_name;
				destination_object_part = source_object_part;
                            }
                            if (0 != copy_attribute(source_object_part, source_attribute_part,
                                    destination_object_part, destination_attribute_part)){
                                CMD_ERROR("COPY Attribute command failed");
                            }
                            HDfree(source_object_name);
                            /*HDfree(source_object_part);*/
                            /*HDfree(source_attribute_part);*/
                            source_object_name = NULL;
                            HDfree(copy_param2_name);
                            /*HDfree(destination_object_part);*/
                            /*HDfree(destination_attribute_part);*/
                            copy_param2_name = NULL;
                        }
break;
case 19:
#line 382 "parse.y"
{
                            if (get_debug()) fprintf(stderr, "found copy1 command\n");
                            /* error check */
                            if (!source_object_name){
                                fprintf(stderr, "source object is missing for COPY command\n");
                                leave(EXIT_FAILURE);
                            }
                            if (!copy_param2_name){
                                fprintf(stderr, "source attribute name missing from COPY command\n");
                                leave(EXIT_FAILURE);
                            }
                            if (!destination_object_name){
                                fprintf(stderr, "destination object is missing for COPY command\n");
                                leave(EXIT_FAILURE);
                            }
                            if (!destination_attribute_name){
                                fprintf(stderr, "destination attribute name missing from COPY command\n");
                                leave(EXIT_FAILURE);
                            }
                            /* Execute the COPY command */
                            if (0 != copy_attribute(source_object_name, copy_param2_name, 
                                    destination_object_name, destination_attribute_name)){
                                CMD_ERROR("COPY Attribute command failed");
                            }
                            /* Cleanup */
                            HDfree(source_object_name);
                            HDfree(copy_param2_name);
                            HDfree(destination_object_name);
                            HDfree(destination_attribute_name);
                            source_object_name = NULL;
                            destination_object_name = NULL;
                        }
break;
case 20:
#line 417 "parse.y"
{if (get_debug()) fprintf(stderr, "got attribute name(%s)\n", H5EDITyylval.sval);
			    /* save the attribute name */
			    if (attribute_name != NULL){
				fprintf(stderr, "Already got an attribute name\n");
				leave(EXIT_FAILURE);
			    }
			    if ((attribute_name = HDstrdup(H5EDITyylval.sval)) == NULL){
				fprintf(stderr, "strdup failed\n");
				leave(EXIT_FAILURE);
			    }
			}
break;
case 21:
#line 431 "parse.y"
{if (get_debug()) fprintf(stderr, "got copy_param2 name(%s)\n", H5EDITyylval.sval);
			    if (copy_param2_name != NULL){
                                fprintf(stderr, "Already got second param name\n");
                                leave(EXIT_FAILURE);
                            }
                            if ((copy_param2_name = HDstrdup(H5EDITyylval.sval)) == NULL){
                                fprintf(stderr, "strdup failed\n");
                                leave(EXIT_FAILURE);
                            }
			}
break;
case 22:
#line 444 "parse.y"
{
			    if (get_debug()) fprintf(stderr, "got attrname_old(%s)\n", attribute_name);
			    /* copy the attribute name to old attribute name and reset
			       attributename. */
			    if (attribute_name_old != NULL){
				fprintf(stderr, "Already got a old attribute name\n");
				leave(EXIT_FAILURE);
			    }
			    attribute_name_old = attribute_name;
			    attribute_name = NULL;
			}
break;
case 23:
#line 459 "parse.y"
{
			    if (get_debug()) fprintf(stderr, "got attrname_new(%s)\n", attribute_name);
			    /* copy the attribute name to new attribute name and reset
			       attributename. */
			    if (attribute_name_new != NULL){
				fprintf(stderr, "Already got a new attribute name\n");
				leave(EXIT_FAILURE);
			    }
			    attribute_name_new = attribute_name;
			    attribute_name = NULL;
			}
break;
case 24:
#line 473 "parse.y"
{if (get_debug()) fprintf(stderr, "got source object name(%s)\n", H5EDITyylval.sval);
                            /* save the source object name */
                            if (source_object_name != NULL){
                                fprintf(stderr, "Already got a source object name\n");
                                leave(EXIT_FAILURE);
                            }
                            if ((source_object_name = HDstrdup(H5EDITyylval.sval)) == NULL){
                                fprintf(stderr, "strdup failed\n");
                                leave(EXIT_FAILURE);
                            }
                        }
break;
case 25:
#line 487 "parse.y"
{if (get_debug()) fprintf(stderr, "got destination object name(%s)\n", H5EDITyylval.sval);
                            /* save the destination object name */
                            if (destination_object_name != NULL){
                                fprintf(stderr, "Already got a destination object name\n");
                                leave(EXIT_FAILURE);
                            }
                            if ((destination_object_name = HDstrdup(H5EDITyylval.sval)) == NULL){
                                fprintf(stderr, "strdup failed\n");
                                leave(EXIT_FAILURE);
                            }
                        }
break;
case 26:
#line 501 "parse.y"
{if (get_debug()) fprintf(stderr, "got destination attribute name(%s)\n", H5EDITyylval.sval);
                            /* save the destination attribute name */
                            if (destination_attribute_name != NULL){
                                fprintf(stderr, "Already got a destination attribute name\n");
                                leave(EXIT_FAILURE);
                            }
                            if ((destination_attribute_name = HDstrdup(H5EDITyylval.sval)) == NULL){
                                fprintf(stderr, "strdup failed\n");
                                leave(EXIT_FAILURE);
                            }
                        }
break;
case 30:
#line 521 "parse.y"
{if (get_debug()) fprintf(stderr, "got dataset name(%s)\n", H5EDITyylval.sval);
			    /* save the dataset name */
			    if (dataset_name != NULL){
				fprintf(stderr, "Already got an dataset name\n");
				leave(EXIT_FAILURE);
			    }
			    if ((dataset_name = HDstrdup(H5EDITyylval.sval)) == NULL){
				fprintf(stderr, "strdup failed\n");
				leave(EXIT_FAILURE);
			    }
			}
break;
case 31:
#line 535 "parse.y"
{if (get_debug()) fprintf(stderr, "got group name(%s)\n", H5EDITyylval.sval);
			    /* save the group name */
			    if (group_name != NULL){
				fprintf(stderr, "Already got an group name\n");
				leave(EXIT_FAILURE);
			    }
			    if ((group_name = HDstrdup(H5EDITyylval.sval)) == NULL){
				fprintf(stderr, "strdup failed\n");
				leave(EXIT_FAILURE);
			    }
			}
break;
case 37:
#line 561 "parse.y"
{ if (get_debug()) fprintf(stderr, "found attribute definition\n");

			}
break;
case 48:
#line 586 "parse.y"
{
			    if (get_debug()) fprintf(stderr, "found string type\n");
			    if (attribute_type_class != H5T_NO_CLASS){
				fprintf(stderr, "Already has an attribute data type\n");
				leave(EXIT_FAILURE);
			    }
			    attribute_type_class = H5T_STRING;
			    /* for now, assume it is null-terminated strings */
			    if ((attribute_type_id=H5Tcopy(H5T_C_S1)) < 0){
				fprintf(stderr, "Attribute string type create failure\n");
				leave(EXIT_FAILURE);
			    }
			    if (H5Tset_size(attribute_type_id,str_size) < 0){
				fprintf(stderr, "Attribute string size set failure\n");
				leave(EXIT_FAILURE);
			    }
			    if (H5Tset_strpad(attribute_type_id, H5T_STR_NULLTERM) < 0){
				fprintf(stderr, "Attribute string pad set failure\n");
				leave(EXIT_FAILURE);
			    }
			}
break;
case 49:
#line 610 "parse.y"
{
			    if (get_debug()) fprintf(stderr, "found string size\n");
			}
break;
case 50:
#line 616 "parse.y"
{   /* Must test value range before assign it to str_zize */
			    /* which is size_t type which is unsigned. */
			    if (get_debug()) fprintf(stderr, "String size is (%d)\n",
				    H5EDITyylval.ival);
			    if (H5EDITyylval.ival <= 0){
				fprintf(stderr, "String size must be positive (%d)\n",
				    H5EDITyylval.ival);
				leave(EXIT_FAILURE);
			    }
			    str_size = H5EDITyylval.ival;
			}
break;
case 53:
#line 634 "parse.y"
{
			    if (get_debug()) fprintf(stderr, "found integer type(%s)\n",
				H5EDITyylval.sval);
			    if (attribute_type_class != H5T_NO_CLASS){
				fprintf(stderr, "Already has an attribute data type\n");
				leave(EXIT_FAILURE);
			    }
			    attribute_type_class = H5T_INTEGER;
			    if ((attribute_type_id=H5LTtext_to_dtype(H5EDITyylval.sval, H5LT_DDL)) < 0){
				fprintf(stderr, "Attribute type create failure\n");
				leave(EXIT_FAILURE);
			    }
			}
break;
case 54:
#line 650 "parse.y"
{
			    if (get_debug()) fprintf(stderr, "found float type(%s)\n",
				H5EDITyylval.sval);
			    if (attribute_type_class != H5T_NO_CLASS){
				fprintf(stderr, "Already has an attribute data type\n");
				leave(EXIT_FAILURE);
			    }
			    attribute_type_class = H5T_FLOAT;
			    if ((attribute_type_id=H5LTtext_to_dtype(H5EDITyylval.sval, H5LT_DDL)) < 0){
				fprintf(stderr, "Attribute type create failure\n");
				leave(EXIT_FAILURE);
			    }
			}
break;
case 60:
#line 676 "parse.y"
{
			    if (get_debug()) fprintf(stderr, "found scalar dataspace\n");
			    attribute_space_class = H5S_SCALAR;
			    if (attribute_space_id != -1){
				fprintf(stderr, "Already has an attribute space\n");
				leave(EXIT_FAILURE);
			    }
			    if ((attribute_space_id=H5Screate(H5S_SCALAR)) < 0){
				fprintf(stderr, "Attribute space create failure\n");
				leave(EXIT_FAILURE);
			    }
			    attribute_data_needed = 1;
			}
break;
case 63:
#line 697 "parse.y"
{
			    if (get_debug()) fprintf(stderr, "looking for dimlist\n");
			    attribute_space_class = H5S_SIMPLE;
			    /* reset attribute dimension information */
			    HDmemset(&attribute_dims, 0, sizeof(attribute_dims));
			}
break;
case 64:
#line 705 "parse.y"
{
			    if (get_debug()){
				int i;
				fprintf(stderr, "found simple dataspace\n");
				fprintf(stderr, "rank=%d:\n", attribute_dims.ndims);
				for (i=0; i<attribute_dims.ndims; i++){
				    fprintf(stderr, "%ld\n", (long) attribute_dims.dims[i]);
				}
			    }
			    if (attribute_space_id != -1){
				fprintf(stderr, "Already has an attribute space\n");
				leave(EXIT_FAILURE);
			    }
			    if ((attribute_space_id=H5Screate_simple(attribute_dims.ndims,
				    &(attribute_dims.dims), NULL)) < 0 ){
				fprintf(stderr, "Attribute space create failure\n");
				leave(EXIT_FAILURE);
			    }
			    /* Calculate number of data elements needed */
			    attribute_data_needed = attribute_dims.dims[0];
			    {   int i;
				for (i=1; i < attribute_dims.ndims; i++){
				    attribute_data_needed *= attribute_dims.dims[i];
				}
				if (get_debug()) fprintf(stderr, "attribute data needed=%d\n",
					attribute_data_needed);
			    }
			    /* AKC: I don't like the coding here. */
			    /* It is repeating code.  Need to fix it later. */
			    /* Default datatype is Native Float */
			    if ( attribute_type_class == H5T_NO_CLASS){
				attribute_type_class = H5T_FLOAT;
				if ((attribute_type_id=H5Tcopy(H5T_NATIVE_FLOAT)) < 0){
				    fprintf(stderr, "Attribute default type create failure\n");
				    leave(EXIT_FAILURE);
				}
			    }
			    switch (attribute_type_class){
			    case H5T_INTEGER:
			    case H5T_FLOAT:
				if (attribute_data_needed > DATA_SIZE_MAX){
				    fprintf(stderr,
					"Too many attribute data needed(%d). "
					"Maximum is %d\n",
					attribute_data_needed, DATA_SIZE_MAX);
				    leave(EXIT_FAILURE);
				}
				break;
			    case H5T_STRING:
				if ((attribute_data_needed*str_size) > sizeof(attribute_data)){
				    fprintf(stderr,
					"Too much attribute string data needed(%d). "
					"Maximum is %d\n",
					(int)attribute_data_needed*str_size,
					sizeof(attribute_data));
				    leave(EXIT_FAILURE);
				}
				break;
			    default:
				fprintf(stderr, "Unsupported data type(%d)\n",
				    attribute_type_class);
				leave(EXIT_FAILURE);
			    }
			}
break;
case 65:
#line 772 "parse.y"
{   /* first dimension */
			    if (H5EDITyylval.ival <=0){
				fprintf(stderr, "Dimension must be positive. Got %d.\n",
				    H5EDITyylval.ival);
				leave(EXIT_FAILURE);
			    }
			    attribute_dims.dims[attribute_dims.ndims] = H5EDITyylval.ival;
			    attribute_dims.ndims++;
			}
break;
case 68:
#line 788 "parse.y"
{   /* more dimensions */
			    if (attribute_dims.ndims >= H5S_MAX_RANK){
				fprintf(stderr, "Too many dimensions. Maximun is %d\n",
				    H5S_MAX_RANK);
				leave(EXIT_FAILURE);
			    }
			    if (H5EDITyylval.ival <=0){
				fprintf(stderr, "Dimension must be positive. Got %d.\n",
				    H5EDITyylval.ival);
				leave(EXIT_FAILURE);
			    }
			    attribute_dims.dims[attribute_dims.ndims] = H5EDITyylval.ival;
			    attribute_dims.ndims++;
			}
break;
case 72:
#line 813 "parse.y"
{
			    /* get the data buffer ready for new data */
			    if (get_debug()) fprintf(stderr, "found attribute data\n");
			    attribute_data_gotten = 0;
			    attribute_data_pt = &(attribute_data.data_string);
			    /* Default datatype is Native Float */
			    if ( attribute_type_class == H5T_NO_CLASS){
				attribute_type_class = H5T_FLOAT;
				if ((attribute_type_id=H5Tcopy(H5T_NATIVE_FLOAT)) < 0){
				    fprintf(stderr, "Attribute default type create failure\n");
				    leave(EXIT_FAILURE);
				}
			    }
			    /* Default dataspace is SCALAR */
			    if (attribute_space_id == -1){
				attribute_space_class = H5S_SCALAR;
				if ((attribute_space_id=H5Screate(H5S_SCALAR)) < 0){
				    fprintf(stderr, "Attribute default space create failure\n");
				    leave(EXIT_FAILURE);
				}
				attribute_data_needed = 1;
			    }
			}
break;
case 73:
#line 837 "parse.y"
{
			    if (attribute_data_gotten < attribute_data_needed){
				fprintf(stderr, "Fewer data than needed. "
				    "Need %d but got %d data only\n",
				    attribute_data_needed, attribute_data_gotten);
				leave(EXIT_FAILURE);
			    }
			}
break;
case 74:
#line 846 "parse.y"
{ /* no action */
			}
break;
case 79:
#line 861 "parse.y"
{
			    if (attribute_data_gotten >= attribute_data_needed){
				fprintf(stderr, "More data than needed. Only %d are needed.\n",
				    attribute_data_needed);
				leave(EXIT_FAILURE);
			    }
			    if (attribute_type_class != H5T_INTEGER){
				fprintf(stderr, "Gotten incorrect type of data\n");
				leave(EXIT_FAILURE);
			    }
			    attribute_data.data_int[attribute_data_gotten++] = H5EDITyylval.ival;
			}
break;
case 80:
#line 875 "parse.y"
{
			    if (attribute_data_gotten >= attribute_data_needed){
				fprintf(stderr, "More data than needed. Only %d are needed.\n",
				    attribute_data_needed);
				leave(EXIT_FAILURE);
			    }
			    if (attribute_type_class != H5T_FLOAT){
				fprintf(stderr, "Gotten incorrect type of data\n");
				leave(EXIT_FAILURE);
			    }
			    attribute_data.data_float[attribute_data_gotten++] = H5EDITyylval.fval;
			}
break;
case 81:
#line 888 "parse.y"
{
			    if (attribute_data_gotten >= attribute_data_needed){
				fprintf(stderr, "More data than needed. Only %d are needed.\n",
				    attribute_data_needed);
				leave(EXIT_FAILURE);
			    }
			    if (attribute_type_class != H5T_STRING){
				fprintf(stderr, "Gotten incorrect type of data\n");
				leave(EXIT_FAILURE);
			    }
			    switch (attribute_space_class) {
			    case H5S_SCALAR:
				/* this works for scalar only. Copy the
				 * string_const to attribute_data. */
				if (attribute_data_gotten > 0 ){
				    fprintf(stderr, "More data than needed. Only %d are needed.\n",
					attribute_data_needed);
				    leave(EXIT_FAILURE);
				}
				HDstrncpy(attribute_data_pt, H5EDITyylval.sval, str_size);
				/* move data pointer forward */
				attribute_data_pt += str_size;
				attribute_data_gotten++;
				break;
			    case H5S_SIMPLE:
				/* This should work for SIMPLE space */
				/* this is not working
				fprintf(stderr, "not able to support string type of SIMPLE space\n");
				leave(EXIT_FAILURE);
				*/
				HDstrncpy(attribute_data_pt, H5EDITyylval.sval, str_size);
				/* move data pointer forward */
				attribute_data_pt += str_size;
				attribute_data_gotten++;
				break;
			    default:
				fprintf(stderr, "Do not know how to store string_const "
				    "of this kind of data space(%d)\n",
				    attribute_space_class);
				leave(EXIT_FAILURE);
			    }
			}
break;
case 84:
#line 940 "parse.y"
{
			    if (get_debug()){
				fprintf(stderr, "found rename command 1\n");
				fprintf(stderr, "attribute_name_old=%s(%x), group_name=%s, dataset_name=%s, attribute_name_new=%s(%x)\n",
				    (attribute_name_old?attribute_name_old:"null"), attribute_name_old,
				    (group_name?group_name:"null"),
				    (dataset_name?dataset_name:"null"),
				    (attribute_name_new?attribute_name_new:"null"), attribute_name_new
				);
			    }
			    /* error check */
			    if (!attribute_name_old){
				fprintf(stderr, "old attribute name missing from RENAME command 1\n");
				leave(EXIT_FAILURE);
			    }
			    if (!attribute_name_new){
				fprintf(stderr, "new attribute name missing from RENAME command 1\n");
				leave(EXIT_FAILURE);
			    }
			    if (!dataset_name && !group_name){
				fprintf(stderr, "neither dataset nor group name is provided for RENAME command 1\n");
				leave(EXIT_FAILURE);
			    }
			    /* Execute the RENAME command */
			    if (0 != rename_attribute(attribute_name_old, group_name, dataset_name, attribute_name_new)){
				CMD_ERROR("RENAME Attribute command failed");
			    }
			    /* Cleanup */
			    HDfree(attribute_name_old);
			    attribute_name_old = NULL;
			    HDfree(attribute_name_new);
			    attribute_name_new = NULL;
			    if (group_name){
				HDfree(group_name);
				group_name = NULL;
			    }
			    if (dataset_name){
				HDfree(dataset_name);
				dataset_name = NULL;
			    }
			    if (get_debug()) fprintf(stderr, "finished rename command 1\n");
			}
break;
case 85:
#line 986 "parse.y"
{
			    if (get_debug()){
				fprintf(stderr, "found rename command 2\n");
				fprintf(stderr, "attribute_name_old=%s(%x), group_name=%s, dataset_name=%s, attribute_name_new=%s(%x)\n",
				    (attribute_name_old?attribute_name_old:"null"), attribute_name_old,
				    (group_name?group_name:"null"),
				    (dataset_name?dataset_name:"null"),
				    (attribute_name_new?attribute_name_new:"null"), attribute_name_new
				);
			    }
			    /* error check */
			    if (!attribute_name_new){
				fprintf(stderr, "new attribute name missing from RENAME command 2\n");
				leave(EXIT_FAILURE);
			    }
			    if (!dataset_name && !group_name){
				fprintf(stderr, "neither dataset nor group name is provided for RENAME command 2\n");
				leave(EXIT_FAILURE);
			    }
			    /* Execute the RENAME command */
			    if (0 != rename_attribute(NULL, group_name, dataset_name, attribute_name_new)){
				CMD_ERROR("RENAME Attribute command failed");
			    }
			    /* Cleanup */
			    HDfree(attribute_name_new);
			    attribute_name_new = NULL;
			    if (group_name){
				HDfree(group_name);
				group_name = NULL;
			    }
			    if (dataset_name){
				HDfree(dataset_name);
				dataset_name = NULL;
			    }
			    if (get_debug()) fprintf(stderr, "finished rename command 2\n");
			}
break;
#line 1569 "parse.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yysslim && yygrowstack())
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
